## Script (Python) "getPaymentsFolderInfo"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: getPaymentsFolderInfo.py 2761 2007-11-26 09:45:58Z henrik $
"""
Info for the PaymentsFolder
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass
"""

mtool = context.portal_membership
if mtool.isAnonymousUser():
    return None

#import logging
#logger = logging.getLogger('Skins.getPaymentsFolderInfo')
def cmp_id(a,b):
    s1 = "%(id)s" % a
    s2 = "%(id)s" % b
    if s1 == s2:
        return 0
    if s1 > s2:
        return 1
    return -1

import DateTime
request = context.REQUEST
students = context.portal_url.getPortalObject().campus.students
student_id = context.getStudentId()
if student_id is None:
    return context.REQUEST.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())
student = getattr(students,student_id)
student_record = context.students_catalog.getRecordByKey(student_id)
context['updatePayments']()
payments = []

info = {}
is_so = info['is_so'] = context.isSectionOfficer()
is_student = info['is_student'] = context.isStudent()
info['student_name'] = student_record.name
info['query_url'] = "https://webpay.interswitchng.com/paydirect/services/TransactionQueryURL.aspx"
review_state = info['review_state'] = student_record.review_state
parttime = student_record.mode and student_record.mode.endswith('_pt')
fulltime = student_record.mode and student_record.mode.endswith('_ft')

#if review_state == 'cleared_and_validated' or (parttime and review_state == 'returning'):
#    online_payment = True
#elif fulltime and review_state == 'returning':
#    sc_payment = True

session = student_record.session
next_info = context.getNextInfo(student_record)
info['next_session'] = next_info['next_session_id']
info['next_session_str'] = next_info['next_session_str']
info['payment_method'] = ""
info['reasons'] = next_info['reasons']

if review_state == 'cleared_and_validated':
    info['payment_method'] = "online_payment"
elif review_state == 'returning' and info['next_session'] != session:
    info['payment_method'] = "sc_payment"
info['prod_id'] = '61'

info['student_name'] = student_record.name
payments_path = "%s/campus/students/%s/payments" % (context.portal_url.getPortalPath(),student_id)
sos = context.portal_catalog(container_path=payments_path)
info['is_so'] = is_so

for so in sos:
    row = {}
    row['id'] = so.getId
    row['title'] = so.Title
    url = row['url'] = "%s/%s" % (payments_path,so.getId)
    so_doc = context.restrictedTraverse(url,default=None).getContent()
    row['type'] = so.portal_type
    review_state = row['review_state'] = so.review_state
    if so_doc.type_description.startswith('School Fee'):
        row['is_approvable'] = is_so and (review_state == "opened") and info['review_state'] == 'cleared_and_validated'
    else:
        row['is_approvable'] = is_so and (review_state == "opened")
    row['is_requeryable'] = False
    #set_trace()
    row['resp_desc'] = getattr(so_doc,'resp_desc','no response')
    row['trans_ref'] = getattr(so_doc,'order_id','')
    if so_doc.type_description.startswith('School Fee'):
        if review_state == 'opened' and info['review_state'] == 'cleared_and_validated' and hasattr(so_doc, 'order_id') and not so_doc.resp_code:
            row['is_requeryable'] = True
            row['callback_url'] = "%s/payments/%s/interswitch_cb" % (student.absolute_url(),
                                                            so.getId)
            href = '%(query_url)s' % info
            href += '?transRef=%(trans_ref)s' % row
            href += '&prodID=%(prod_id)s' % info
            href += '&redirectURL=%(callback_url)s' % row
            row['href'] = href
    if (review_state == "closed") and so_doc.resp_code in ('SC','00','AP','IP',):
        row['confirmed'] = 'active'
    else:
        row['confirmed'] = 'unsuccessful'
    row['is_editable'] = is_so and (row['confirmed'] == 'active')

    payments.append(row)

payments.sort(cmp_id)
info['payments'] = payments
return info

